//---------------------------------------------------------------------------
// BUFFER.HPP
//---------------------------------------------------------------------------
// Revision History
// 07/08/94 - Initial Revision
//---------------------------------------------------------------------------

#if !defined(__BUFFER_HPP)
#define __BUFFER_HPP

#include <windows.h>
#include <cstring.h>
#include <except.h>

//---------------------------------------------------------------------------
// class: BUFBNDS - execption - bounds error
//---------------------------------------------------------------------------
class _EXPCLASS BUFBNDS : public xmsg {
public:
                                 BUFBNDS                 (const string &msg)  : xmsg(msg) {};
                                 BUFBNDS                 (BUFBNDS &e)         : xmsg(e) {};
   BUFBNDS &                     operator =              (BUFBNDS &e)         {xmsg::operator=(e); return *this; };
   };

//---------------------------------------------------------------------------
// class: BUFFER
//---------------------------------------------------------------------------
class _EXPCLASS BUFFER {
public:
                                 BUFFER                  (void);
                                 BUFFER                  (UINT maxlen);
                                 BUFFER                  (BUFFER&);
                                 ~BUFFER                 (void);
                                 operator LPSTR          (void)               {return (LPSTR)Buffer; };
   BUFFER &                      operator =              (BUFFER&);
   LPVOID                        operator &              (void)               {return Buffer; };
   char &                        operator []             (UINT);
   BUFFER &                      operator <<             (LPCSTR);
   BUFFER &                      operator <<             (BOOL&);
   BUFFER &                      operator <<             (BYTE&);
   BUFFER &                      operator <<             (WORD&);
   BUFFER &                      operator <<             (DWORD&);
   BUFFER &                      operator <<             (UINT&);
   BUFFER &                      operator <<             (LONG&);
   BUFFER &                      operator <<             (string&);
   BUFFER &                      operator <<             (float&);
   BUFFER &                      operator <<             (double&);
   BUFFER &                      operator <<             (BUFFER&);

   BUFFER &                      operator >>             (string&);

   UINT                          GetMaxLen               (void)               {return MaxLen; };
   void                          SetMaxLen               (UINT len);

   UINT                          GetLen                  (void)               {return CurLen; };
   void                          SetLen                  (UINT len = 0)       {CurLen = (len) ? len : MaxLen; };

   void                          SetBuffer               (LPVOID buf, UINT maxlen, UINT len);

   void                          SetData                 (LPVOID buf, UINT len);
   void                          GetData                 (LPVOID buf, UINT len);
protected:
   UINT                          CurLen;
   UINT                          CurOut;     // for stream out operations
   UINT                          MaxLen;
   LPVOID                        Buffer;
   BOOL                          Allocated;

   void                          Alloc                   (void);
   void                          Realloc                 (UINT newlen);
   void                          Dealloc                 (void);

   void                          StreamIn                (LPCSTR, UINT);

   void                          init                    (UINT maxlen = 0);
   void                          copy                    (BUFFER&);
   };

#endif // __BUFFER_HPP
